/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tupletest1;


import java.io.IOException;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.Diagnostician;
import org.eclipse.emf.ecore.xmi.impl.EcoreResourceFactoryImpl;
import org.eclipse.emf.ecore.xmi.impl.XMIResourceFactoryImpl;
import org.eclipse.ocl.ecore.TupleType;
import org.eclipse.ocl.examples.pivot.delegate.OCLDelegateDomain;
import org.eclipse.ocl.examples.pivot.delegate.OCLInvocationDelegateFactory;
import org.eclipse.ocl.examples.pivot.delegate.OCLSettingDelegateFactory;
/**
 *
 * @author khurrams
 */
public class TestTuple {
    private EPackage modelPackage = null;
    private EClass eClass = null;
    private EAttribute eAttribute = null;
    private EFactory iModelPackage = null;
    private EObject eObject = null;
    private EOperation eOperation;
    private String oclDelegateURI = OCLDelegateDomain.OCL_DELEGATE_URI_PIVOT;
    private ResourceSet ecoreResourceSet;
    private ResourceSet xmiResourceSet;
    
    public TestTuple() {

        EOperation.Internal.InvocationDelegate.Factory.Registry.INSTANCE.put
        (oclDelegateURI, new OCLInvocationDelegateFactory.Global());
        EStructuralFeature.Internal.SettingDelegate.Factory.Registry.INSTANCE.put(oclDelegateURI, new OCLSettingDelegateFactory.Global());
    	makeMataModel();      
    }    
    private void makeMataModel() {
         modelPackage = EcoreFactory.eINSTANCE.createEPackage();
         modelPackage.setName("temp");
         modelPackage.setNsPrefix("Test");
         modelPackage.setNsURI("http://www.eclipse.org/mdt/ocl/oclinecore/tutorial");
         EAnnotation mainOCLAnnotation = EcoreFactory.eINSTANCE.createEAnnotation();
         mainOCLAnnotation.setSource("http://www.eclipse.org/emf/2002/Ecore");
         mainOCLAnnotation.getDetails().put("invocationDelegates", oclDelegateURI);
         mainOCLAnnotation.getDetails().put("settingDelegates", oclDelegateURI);
         mainOCLAnnotation.getDetails().put("validationDelegates", oclDelegateURI);
         modelPackage.getEAnnotations().add(mainOCLAnnotation);
         eClass = EcoreFactory.eINSTANCE.createEClass();
         eClass.setName("TestClass");
         
         eAttribute= EcoreFactory.eINSTANCE.createEAttribute();
         eAttribute.setName("test");
         eAttribute.setUpperBound(1);
         eAttribute.setLowerBound(1);
         eAttribute.setEType(EcorePackage.eINSTANCE.getEDoubleObject());
         eAttribute.setDerived(true);
         eAttribute.setVolatile(true);
         EAnnotation driveAnnotation = EcoreFactory.eINSTANCE.createEAnnotation();
         driveAnnotation.setSource(oclDelegateURI);
         driveAnnotation.getDetails().put("derivation", "let t : Tuple(a:Real , b:Real) = opt() in t.a*4");
         eAttribute.getEAnnotations().add(driveAnnotation);
         eClass.getEStructuralFeatures().add(eAttribute);
         
        
         
         TupleType tt = org.eclipse.ocl.ecore.EcoreFactory.eINSTANCE.createTupleType();
         EAttribute eAttributePart1 = EcoreFactory.eINSTANCE.createEAttribute();
         EAttribute eAttributePart2 = EcoreFactory.eINSTANCE.createEAttribute();
         eAttributePart1.setEType(EcorePackage.eINSTANCE.getEDouble());
         eAttributePart1.setName("a");
         eAttributePart1.setUpperBound(1);
         eAttributePart1.setLowerBound(1);
         eAttributePart1.setUnique(false);
         eAttributePart1.setOrdered(false);         
         
         eAttributePart2.setEType(EcorePackage.eINSTANCE.getEDouble());
         eAttributePart1.setName("b");
         eAttributePart2.setUpperBound(1);
         eAttributePart2.setLowerBound(1);
         eAttributePart2.setUnique(false);
         eAttributePart2.setOrdered(false);
         
         tt.getEStructuralFeatures().add(eAttributePart1);
         tt.oclProperties().add(eAttributePart1);
         tt.getEStructuralFeatures().add(eAttributePart2);
         tt.oclProperties().add(eAttributePart2);
         
         
         
         eOperation = EcoreFactory.eINSTANCE.createEOperation();
         EAnnotation eAnnotation = EcoreFactory.eINSTANCE.createEAnnotation();
         eAnnotation.setSource(oclDelegateURI);
         eAnnotation.getDetails().put("body", "let t : Tuple(a:Real, b:Real) = Tuple{a=2, b=2} in t ");
         eOperation.setName("opt");
         eOperation.getEAnnotations().add(eAnnotation);
         eOperation.setEType(tt);
         eOperation.setOrdered(false);
         eOperation.setUnique(false);
         eOperation.setLowerBound(1);
         eOperation.setUpperBound(1);
         eClass.getEOperations().add(eOperation);
         
         
         modelPackage.getEClassifiers().add(eClass);
         URI uri1 = URI.createFileURI("test.ecore");
         ecoreResourceSet = new ResourceSetImpl();
         ecoreResourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("ecore", new EcoreResourceFactoryImpl());
         Resource resource = ecoreResourceSet.createResource(uri1);
         resource.getContents().add(modelPackage);
         resource.getContents().add(tt);
         Diagnostic dig = Diagnostician.INSTANCE.validate(modelPackage);
         System.out.println(dig.getMessage());
         for(Diagnostic digc : dig.getChildren()) {
        	 System.out.println(digc.getMessage());
         }

          
    }
    
    public void createModel() {
         iModelPackage = modelPackage.getEFactoryInstance();
         eObject = iModelPackage.create(eClass);
         URI uri = URI.createFileURI("test.xmi");
         xmiResourceSet = new ResourceSetImpl();
         xmiResourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("xmi", new XMIResourceFactoryImpl());
         Resource resource = xmiResourceSet.createResource(uri);
         resource.getContents().add(iModelPackage);
         resource.getContents().add(eObject);
         
    }

    
    public void useDelegates() {
         Object eGet = eObject.eGet(eAttribute, false);
         System.out.println("value = " + eGet.toString());
    }
    
    public static void main(String args[]) {
        TestTuple tp = new TestTuple();
        tp.useDelegates();
    }
}
